/* WlanFE, with tabs */


#include<stdlib.h>
#include<stdio.h>
#include<gtk/gtk.h>
#include<string.h>

#define WLANCTL "wlanctl-ng"

char *SSID_LOAD;
char *INTFACE_LOAD;
char *CHAN_LOAD;

GtkWidget *help_window;
GtkWidget *results_text;
GtkWidget *wep_toggle;
GtkWidget *intface_box;
GtkWidget *key0_radio;
GtkWidget *key1_radio;
GtkWidget *key2_radio;
GtkWidget *key3_radio;
GtkWidget *key0_box;
GtkWidget *key1_box;
GtkWidget *key2_box;
GtkWidget *key3_box;
GSList *mode_group=NULL;
GtkWidget *adhoc_radio;
GtkWidget *infra_radio;
GtkWidget *mon_radio;
GtkWidget *ssid_box;
GtkWidget *chan_combo;
GtkWidget *file_selector;
gchar *selected_filename;


gint delete_event ();
void create_main_window ();
void help_clicked ();
void create_help_window ();
void delete_event_help_window ();
void apply_clicked ();
void send_command (char *wlanctl_command);
void reset_card ();
void open_file_selection ();
void open_file ();
void save_file_selection ();
void save_file ();


gint delete_event ()
{
  gtk_main_quit ();
  return(FALSE);
}


void store_filename()
{
	selected_filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION(file_selector));
}


void create_main_window ()
{
  GtkWidget *main_table;
  GtkWidget *setup_tab;
  GtkWidget *ssid_label;
  GtkWidget *window;
  GtkWidget *notebook;
  GtkWidget *setup_tab_label;
  GtkWidget *wep_tab;
  GtkWidget *wep_tab_label;
  GtkWidget *results_tab;
  GtkWidget *results_tab_label;
  GtkWidget *results_toggle;
  GtkWidget *chan_label;
  GList *chan_list=NULL;
  GtkWidget *key0_label;
  GtkWidget *key1_label;
  GtkWidget *key2_label;
  GtkWidget *key3_label;
  GSList *key_group=NULL;
  GtkWidget *results_window;
  GtkWidget *apply_button;
  GtkWidget *cancel_button;
  GtkWidget *main_label;
  GtkWidget *main_tab;
  GtkWidget *main_tab_label;
  GtkWidget *help_button;
  GtkWidget *intface_label;
  GtkWidget *file_tab;
  GtkWidget *file_tab_label;
  GtkWidget *open_button;
  GtkWidget *save_button;
  GtkWidget *file_label;

  
  /* main window is created */

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL );
  gtk_window_set_title (GTK_WINDOW (window), "WLanFE 1.0.1");
  gtk_signal_connect (GTK_OBJECT (window), "delete_event", GTK_SIGNAL_FUNC (delete_event), NULL);
  gtk_container_set_border_width (GTK_CONTAINER (window), 10);

  /* main table is created */

  main_table = gtk_table_new (4,3, FALSE);
  gtk_container_add (GTK_CONTAINER (window),main_table);
  gtk_widget_show (main_table);
  gtk_table_set_row_spacings (GTK_TABLE (main_table),5);
  gtk_table_set_col_spacings (GTK_TABLE (main_table),5);

  /* notebook is created */

  notebook = gtk_notebook_new ();
  gtk_table_attach_defaults (GTK_TABLE (main_table), notebook,0,4,1,2);
  gtk_widget_show (notebook);


  /* notebook children creations */

  /* Main Tab */

  main_tab = gtk_table_new (1,1, FALSE);
  main_tab_label = gtk_label_new ("Main");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), main_tab, main_tab_label);
  main_label = gtk_label_new ("WlanFE - The Linux Wireless Front End");
  gtk_table_attach_defaults (GTK_TABLE (main_tab),main_label,0,1,0,1);
  gtk_widget_show (main_tab);
  gtk_widget_show (main_label);

  /* Setup Tab */

  setup_tab = gtk_table_new (2,6, FALSE);

  /* interface label */

  intface_label=gtk_label_new ("Interface");
  gtk_table_attach_defaults (GTK_TABLE (setup_tab), intface_label,0,1,0,1);
  gtk_widget_show (intface_label);

  /* interface box */

  intface_box=gtk_entry_new_with_max_length (32);
  gtk_entry_set_text (GTK_ENTRY (intface_box), INTFACE_LOAD);
  gtk_table_attach_defaults (GTK_TABLE (setup_tab), intface_box, 1,2,0,1);
  gtk_widget_show (intface_box);

  
  /* ssid label */

  ssid_label=gtk_label_new ("SSID");
  gtk_table_attach_defaults (GTK_TABLE (setup_tab), ssid_label, 0,1,1,2);
  gtk_widget_show (ssid_label);
  
  /*ssid text box */

  ssid_box = gtk_entry_new_with_max_length (32);
  gtk_entry_set_text (GTK_ENTRY (ssid_box),SSID_LOAD);
  gtk_table_attach_defaults (GTK_TABLE (setup_tab), ssid_box, 1,2,1,2);
  gtk_widget_show (ssid_box);

  setup_tab_label=gtk_label_new ("setup");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook),setup_tab,setup_tab_label);
  gtk_widget_show (setup_tab);

  /*channel label*/

  chan_label=gtk_label_new ("channel");
  gtk_table_attach_defaults (GTK_TABLE (setup_tab), chan_label, 0,1,2,3);
  gtk_widget_show (chan_label);

  /* channel combo box*/


  chan_list = g_list_append(chan_list, "1");
  chan_list = g_list_append(chan_list, "2");
  chan_list = g_list_append(chan_list, "3");
  chan_list = g_list_append(chan_list, "4");
  chan_list = g_list_append(chan_list, "5");
  chan_list = g_list_append(chan_list, "6");
  chan_list = g_list_append(chan_list, "7");
  chan_list = g_list_append(chan_list, "8");
  chan_list = g_list_append(chan_list, "9");
  chan_list = g_list_append(chan_list, "10");
  chan_list = g_list_append(chan_list, "11");
  chan_list = g_list_append(chan_list, "12");
  chan_list = g_list_append(chan_list, "13");
  chan_list = g_list_append(chan_list, "14");

  chan_combo = gtk_combo_new ();
  gtk_combo_set_popdown_strings( GTK_COMBO(chan_combo), chan_list) ;
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(chan_combo)->entry), CHAN_LOAD);
  gtk_table_attach_defaults (GTK_TABLE (setup_tab), chan_combo, 1, 2, 2, 3);
  gtk_widget_show(chan_combo);
  
  /* mode selector */

  adhoc_radio = gtk_radio_button_new_with_label (mode_group,"Adhoc Mode");
  mode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (adhoc_radio));
  gtk_table_attach_defaults (GTK_TABLE (setup_tab), adhoc_radio, 1,2,3,4);
  gtk_widget_show (adhoc_radio);

  infra_radio = gtk_radio_button_new_with_label (mode_group,"Infrastructure Mode");
  mode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (infra_radio));
  gtk_table_attach_defaults (GTK_TABLE (setup_tab), infra_radio, 1,2,4,5);
  gtk_widget_show (infra_radio);

  mon_radio = gtk_radio_button_new_with_label (mode_group,"Monitor Mode");
  mode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (mon_radio));
  gtk_table_attach_defaults (GTK_TABLE (setup_tab), mon_radio, 1,2,5,6);
  gtk_widget_show (mon_radio);


  /* Wep Tab */

  wep_tab = gtk_table_new (3,6, FALSE);

  key0_box = gtk_entry_new_with_max_length (38);
  gtk_table_attach_defaults (GTK_TABLE (wep_tab), key0_box, 1,2,0,1);
  gtk_widget_show (key0_box);

  key1_box = gtk_entry_new_with_max_length (38);
  gtk_table_attach_defaults (GTK_TABLE (wep_tab), key1_box, 1,2,1,2);
  gtk_widget_show (key1_box);

  key2_box = gtk_entry_new_with_max_length (38);
  gtk_table_attach_defaults (GTK_TABLE (wep_tab), key2_box, 1,2,2,3);
  gtk_widget_show (key2_box);

  key3_box = gtk_entry_new_with_max_length (38);
  gtk_table_attach_defaults (GTK_TABLE (wep_tab), key3_box, 1,2,3,4);
  gtk_widget_show (key3_box);

  key0_label = gtk_label_new ("WEP Key 1 ");
  gtk_table_attach_defaults (GTK_TABLE (wep_tab), key0_label, 0,1,0,1);
  gtk_widget_show (key0_label);

  key1_label = gtk_label_new ("WEP Key 2 ");
  gtk_table_attach_defaults (GTK_TABLE (wep_tab), key1_label, 0,1,1,2);
  gtk_widget_show (key1_label);

  key2_label = gtk_label_new ("WEP Key 3 ");
  gtk_table_attach_defaults (GTK_TABLE (wep_tab), key2_label, 0,1,2,3);
  gtk_widget_show (key2_label);

  key3_label = gtk_label_new ("WEP Key 4 ");
  gtk_table_attach_defaults (GTK_TABLE (wep_tab), key3_label, 0,1,3,4);
  gtk_widget_show (key3_label);

  key0_radio = gtk_radio_button_new (key_group);
  key_group = gtk_radio_button_group (GTK_RADIO_BUTTON (key0_radio));
  gtk_table_attach_defaults (GTK_TABLE (wep_tab),key0_radio,2,3,0,1);
  gtk_widget_show (key0_radio);

  key1_radio = gtk_radio_button_new (key_group);
  key_group = gtk_radio_button_group (GTK_RADIO_BUTTON (key1_radio));
  gtk_table_attach_defaults (GTK_TABLE (wep_tab),key1_radio,2,3,1,2);
  gtk_widget_show (key1_radio);

  key2_radio = gtk_radio_button_new (key_group);
  key_group = gtk_radio_button_group (GTK_RADIO_BUTTON (key2_radio));
  gtk_table_attach_defaults (GTK_TABLE (wep_tab),key2_radio,2,3,2,3);
  gtk_widget_show (key2_radio);

  key3_radio = gtk_radio_button_new (key_group);
  key_group = gtk_radio_button_group (GTK_RADIO_BUTTON (key3_radio));
  gtk_table_attach_defaults (GTK_TABLE (wep_tab),key3_radio,2,3,3,4);
  gtk_widget_show (key3_radio);

  wep_toggle = gtk_toggle_button_new_with_label ("Wep");
  gtk_table_attach_defaults (GTK_TABLE (wep_tab), wep_toggle, 0,3,5,6);
  gtk_widget_show (wep_toggle);
  

  wep_tab_label=gtk_label_new ("wep");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook),wep_tab,wep_tab_label);
  gtk_widget_show (wep_tab);

  /* Results Tab */
  
  results_window = gtk_scrolled_window_new (NULL,NULL);
  gtk_container_add (GTK_CONTAINER (notebook),results_window);
  results_text = gtk_text_new (NULL,NULL);
  gtk_container_add (GTK_CONTAINER (results_window),results_text);
  
  results_tab_label = gtk_label_new ("results");
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), results_window, results_tab_label);
 
  gtk_widget_show (results_text);
  gtk_widget_show (results_window);
  gtk_widget_show (results_tab_label);

  /* 
  
  file_tab = gtk_table_new (4,6,FALSE);
  file_tab_label=gtk_label_new ("file");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook),file_tab,file_tab_label);
  gtk_widget_show (file_tab);

  file_label=gtk_label_new ("You can load or save your configuration here");
  gtk_table_attach_defaults (GTK_TABLE (file_tab),file_label,0,4,0,2);
  gtk_widget_show (file_label); 
  
  save_button=gtk_button_new_with_label ("save");
  gtk_table_attach_defaults (GTK_TABLE (file_tab),save_button,3,4,5,6);
  gtk_widget_show (save_button);
  gtk_signal_connect (GTK_OBJECT(save_button),"clicked",GTK_SIGNAL_FUNC(save_file_selection),NULL);

  open_button = gtk_button_new_with_label ("load");
  gtk_table_attach_defaults (GTK_TABLE (file_tab),open_button,0,1,5,6);
  gtk_widget_show (open_button);
  gtk_signal_connect (GTK_OBJECT(open_button),"clicked",GTK_SIGNAL_FUNC(open_file_selection),NULL);

  gtk_widget_show (window);

  */

  /* buttons at bottom */

  save_button=gtk_button_new_with_label ("save");
  gtk_table_attach_defaults (GTK_TABLE (main_table),save_button,1,2,2,3);
  gtk_widget_show (save_button);
  gtk_signal_connect (GTK_OBJECT(save_button),"clicked",GTK_SIGNAL_FUNC(save_file_selection),NULL);

  open_button = gtk_button_new_with_label ("load");
  gtk_table_attach_defaults (GTK_TABLE (main_table),open_button,0,1,2,3);
  gtk_widget_show (open_button);
  gtk_signal_connect (GTK_OBJECT(open_button),"clicked",GTK_SIGNAL_FUNC(open_file_selection),NULL);

  apply_button = gtk_button_new_with_label ("apply");
  gtk_table_attach_defaults (GTK_TABLE (main_table),apply_button,3,4,2,3);
  gtk_widget_show (apply_button);
  gtk_signal_connect (GTK_OBJECT (apply_button),"clicked",GTK_SIGNAL_FUNC(apply_clicked),NULL);

  cancel_button = gtk_button_new_with_label ("reset card");
  gtk_table_attach_defaults (GTK_TABLE (main_table),cancel_button,2,3,2,3);
  gtk_widget_show (cancel_button);
  gtk_signal_connect (GTK_OBJECT (cancel_button),"clicked",GTK_SIGNAL_FUNC (reset_card),NULL);

  help_button = gtk_button_new_with_label ("help");
  gtk_table_attach_defaults (GTK_TABLE (main_table),help_button,3,4,0,1);
  gtk_widget_show (help_button);
  gtk_signal_connect (GTK_OBJECT (help_button),"clicked",GTK_SIGNAL_FUNC (help_clicked),NULL);

  gtk_widget_show (window);

}

void help_clicked ()
{
  gtk_widget_show (help_window);
}

void create_help_window ()
{
  GtkWidget *help_scroll;
  GtkWidget *help_text;
  GtkWidget *help_table;
  GtkWidget *help_close;

  char *help_data = "WlanFE Help Window \n\nHelp Window\n\n   To close the help window, use your window managers\n   delete_event button (quite possably a small x in the upper right \n   hand corner).\n\nGeneral\n\n   You can set the options to your liking, then hit the apply button\n   to send those settings to your card. \n\nWEP \n\n   WEP keys must be entered in colon delimited pairs of either 40 \n   or 128 bits, for example 01:02:03:04:05 would be a valid 40 \n   bit WEP key entry or 01:02:03:04:05:06:07:08:09:0a:0b:0c:0d \n   would be a valid 128 bit WEP key entry.  The WEP key entrys\n   must be in hexadecimal.\n   The small radio buttons to the right of each WEP key entry,\n   are used to determine the default key, i.e. if the radio button\n   next to WEP key 1 is active then WEP key 1 is the default WEP\n   key.";

  help_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_signal_connect (GTK_OBJECT (help_window),"delete_event",GTK_SIGNAL_FUNC (delete_event_help_window),NULL);
  gtk_window_set_default_size (GTK_WINDOW (help_window),400,340);
  gtk_window_set_title (GTK_WINDOW (help_window),"WlanFE - Help Dialog");
  gtk_container_set_border_width (GTK_CONTAINER (help_window),0);
  help_scroll = gtk_scrolled_window_new (NULL,NULL);
  gtk_container_add (GTK_CONTAINER (help_window),help_scroll);
  help_text = gtk_text_new (NULL,NULL);
  gtk_text_set_editable (GTK_TEXT (help_text),0);
  gtk_container_add (GTK_CONTAINER (help_scroll), help_text);
  gtk_widget_show (help_scroll);
  gtk_widget_show (help_text);
  gtk_text_insert (GTK_TEXT (help_text),NULL,NULL,NULL,help_data,strlen(help_data));
}

void delete_event_help_window ()
{
  gtk_widget_hide (help_window);
}

void apply_clicked ()
{
  char *cmdbuffer;

  reset_card ();

  cmdbuffer=(char*)calloc(1,750);
  strcat(cmdbuffer," dot11req_mibset mibattribute=dot11WEPDefaultKey0=");
  strcat(cmdbuffer,gtk_entry_get_text(GTK_ENTRY(key0_box)));
  send_command(cmdbuffer);
  free(cmdbuffer);

  cmdbuffer=(char*)calloc(1,750);
  strcat(cmdbuffer," dot11req_mibset mibattribute=dot11WEPDefaultKey1=");
  strcat(cmdbuffer,gtk_entry_get_text(GTK_ENTRY(key1_box)));
  send_command(cmdbuffer);
  free(cmdbuffer);

  cmdbuffer=(char*)calloc(1,750);
  strcat(cmdbuffer," dot11req_mibset mibattribute=dot11WEPDefaultKey2=");
  strcat(cmdbuffer,gtk_entry_get_text(GTK_ENTRY(key2_box)));
  send_command(cmdbuffer);
  free(cmdbuffer);

  cmdbuffer=(char*)calloc(1,750);
  strcat(cmdbuffer," dot11req_mibset mibattribute=dot11WEPDefaultKey3=");
  strcat(cmdbuffer,gtk_entry_get_text(GTK_ENTRY(key3_box)));
  send_command(cmdbuffer);
  free(cmdbuffer);

  if (GTK_TOGGLE_BUTTON (wep_toggle)->active)
    {
      if (GTK_TOGGLE_BUTTON (key3_radio)->active)
	{
	  send_command(" dot11req_mibset mibattribute=dot11WEPDefaultKeyID=3");
	}else if(GTK_TOGGLE_BUTTON (key2_radio)->active){
	  send_command(" dot11req_mibset mibattribute=dot11WEPDefaultKeyID=2");
	}else if(GTK_TOGGLE_BUTTON (key1_radio)->active){
	  send_command(" dot11req_mibset mibattribute=dot11WEPDefaultKeyID=1");
	}else{
	  send_command(" dot11req_mibset mibattribute=dot11WEPDefaultKeyID=0");
	}
      send_command(" dot11req_mibset mibattribute=dot11PrivacyInvoked=true");
    }else{
      send_command(" dot11req_mibset mibattribute=dot11PrivacyInvoked=false");
    }
  if (GTK_TOGGLE_BUTTON (adhoc_radio)->active)
    {
      cmdbuffer=(char*)calloc(1,750);
      strcat(cmdbuffer," dot11req_start ssid=\"");
      strcat(cmdbuffer,gtk_entry_get_text(GTK_ENTRY(ssid_box)));
      strcat(cmdbuffer,"\" bsstype=independent beaconperiod=100 dtimperiod=3 cfpollable=false cfpollreq=false cfpperiod=3 cfpmaxduration=100 probedelay=100 dschannel=");
      strcat(cmdbuffer,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(chan_combo)->entry)));
      strcat(cmdbuffer," basicrate1=2 basicrate2=4 operationalrate1=2 operationalrate2=4 operationalrate3=11 operationalrate4=22");
      send_command(cmdbuffer);
      free(cmdbuffer);
    }else if(GTK_TOGGLE_BUTTON (infra_radio)->active){
      cmdbuffer=(char*)calloc(1,750);
      strcat(cmdbuffer," lnxreq_autojoin ssid=\"");
      strcat(cmdbuffer,gtk_entry_get_text(GTK_ENTRY(ssid_box)));
      strcat(cmdbuffer,"\" authtype=opensystem");
      send_command(cmdbuffer);
      free(cmdbuffer);
    }else if(GTK_TOGGLE_BUTTON (mon_radio)->active){
      cmdbuffer=(char*)calloc(1,750);
      strcat(cmdbuffer," lnxreq_wlansniff channel=");
      strcat(cmdbuffer,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(chan_combo)->entry)));
      strcat(cmdbuffer," enable=true");
      send_command(cmdbuffer);
      free(cmdbuffer);
    }
}

void send_command (char *wlanctl_command)
{
  char *command_pointer;
  void *command_file;
  char *cmdbuffer;

  cmdbuffer=(char*)calloc(1,750);
  command_pointer = (char*)calloc(1,750);
  strcat(cmdbuffer,WLANCTL);
  strcat(cmdbuffer," ");
  strcat(cmdbuffer,gtk_entry_get_text(GTK_ENTRY(intface_box)));
  strcat(cmdbuffer,wlanctl_command);
  command_file = popen(cmdbuffer,"r");
  fread(command_pointer,750,1,command_file);
  gtk_text_insert (GTK_TEXT(results_text),NULL,NULL,NULL,command_pointer,strlen(command_pointer));
  pclose (command_file);
  free(command_pointer);
}

void reset_card ()
{
  send_command (" dot11req_reset setdefaultmib=true");
}

void open_file_selection ()
{
	file_selector = gtk_file_selection_new ("Select A File To Open");

   gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC (open_file),NULL);
	
   gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),(gpointer) file_selector);
	
	gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->cancel_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),(gpointer) file_selector);

	gtk_widget_show (file_selector);
}

void open_file ()
{
	char *test;
	char *testb;
	FILE *fp;
	
	/* open file */
	
	test=(char*)calloc(1,100);
	testb=(char*)calloc(1,100);
	store_filename ();
	fp=fopen(selected_filename,"r");

	/* get interface entry */
	
	fgets (test,100,fp);
	strncat (testb,test,strlen(test)-1);
	gtk_entry_set_text (GTK_ENTRY(intface_box),testb);

	/* get ssid entry */
	
	strncpy (test,"",100);
	strncpy (testb,"",100);
	fgets (test,100,fp);
	strncpy (testb,test,strlen(test)-1);
	gtk_entry_set_text (GTK_ENTRY(ssid_box),testb);

	/* get channel */

	strncpy (test,"",100);
	strncpy (testb,"",100);
	fgets (test,100,fp);
	strncpy (testb,test,strlen(test)-1);
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(chan_combo)->entry), testb);

	/* get mode */

	fgets (test,100,fp);
	if (strncmp(test,"adh",3)==0)
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(adhoc_radio),TRUE);
	}else if (strncmp(test,"mon",3)==0)
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(mon_radio),TRUE);
	}else if (strncmp(test,"inf",3)==0)
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(infra_radio),TRUE);
	}

	/* get wep key 0 */

	strncpy (test,"",100);
	strncpy (testb,"",100);
	fgets (test,100,fp);
	strncpy (testb,test,strlen(test)-1);
	gtk_entry_set_text(GTK_ENTRY(key0_box),testb);
	
	/* get wep key 1 */
	
	strncpy (test,"",100);
	strncpy (testb,"",100);
	fgets (test,100,fp);
	strncpy (testb,test,strlen(test)-1);
	gtk_entry_set_text(GTK_ENTRY(key1_box),testb);

	/* get wep key 2 */

	strncpy (test,"",100);
	strncpy (testb,"",100);
	fgets (test,100,fp);
	strncpy (testb,test,strlen(test)-1);
	gtk_entry_set_text(GTK_ENTRY(key2_box),testb);

	/* get wep key 3 */

	strncpy (test,"",100);
	strncpy (testb,"",100);
	fgets (test,100,fp);
	strncpy (testb,test,strlen(test)-1);
	gtk_entry_set_text(GTK_ENTRY(key3_box),testb);

	/* set active wep key */

	fgets (test,100,fp);
	if (strncmp(test,"0",1)==0)
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(key0_radio),TRUE);
	}else if (strncmp(test,"1",1)==0)
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(key1_radio),TRUE);
	}else if (strncmp(test,"2",1)==0)
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(key2_radio),TRUE);
	}else if (strncmp(test,"3",1)==0)
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(key3_radio),TRUE);
	}

	/* set wep active */

	fgets (test,100,fp);
	if (strncmp(test,"wep on",6)==0)
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(wep_toggle),TRUE);
	}else if (strncmp(test,"wep off",7)==0	)
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(wep_toggle),FALSE);
	}
			
	free(test);
	free(testb);
	fclose(fp);
}

void save_file_selection ()
{
	file_selector = gtk_file_selection_new ("Select A File To Save To");

 	gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC (save_file),NULL);
	
  	gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),(gpointer) file_selector);
	
	gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->cancel_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),(gpointer) file_selector);

	gtk_widget_show (file_selector);
}

void save_file ()
{
	FILE *fp;

	/* open file to write to */
	
	store_filename ();
	fp=fopen(selected_filename,"w");
	
	/* save interface entry */
	
	fputs (gtk_entry_get_text(GTK_ENTRY(intface_box)),fp);
	fputs ("\n",fp);
	
	/* save ssid entry */
	
	fputs (gtk_entry_get_text(GTK_ENTRY(ssid_box)),fp);
	fputs ("\n",fp);
	
	/* save channel entry */
	
	fputs (gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(chan_combo)->entry)),fp);
	fputs ("\n",fp);		
	
	/* save mode */

	if (GTK_TOGGLE_BUTTON (adhoc_radio)->active)
	{
	   fputs ("adhoc",fp);
	}else if (GTK_TOGGLE_BUTTON (mon_radio)->active)
	{
		fputs ("monitor",fp);
	}else if (GTK_TOGGLE_BUTTON (infra_radio)->active)
	{
		fputs ("infrastructure",fp);
	}
	fputs ("\n",fp);

	/* save wep keys */

	fputs (gtk_entry_get_text(GTK_ENTRY(key0_box)),fp);
	fputs ("\n",fp);
	fputs (gtk_entry_get_text(GTK_ENTRY(key1_box)),fp);
	fputs ("\n",fp);
	fputs (gtk_entry_get_text(GTK_ENTRY(key2_box)),fp);
	fputs ("\n",fp);
	fputs (gtk_entry_get_text(GTK_ENTRY(key3_box)),fp);
	fputs ("\n",fp);

	/* save wep active key */

	if (GTK_TOGGLE_BUTTON (key0_radio)->active)
	{
		fputs ("0\n",fp);
	}else if (GTK_TOGGLE_BUTTON (key1_radio)->active)
	{
		fputs ("1\n",fp);
	}else if (GTK_TOGGLE_BUTTON (key2_radio)->active)
	{
		fputs ("2\n",fp);
	}else if (GTK_TOGGLE_BUTTON (key3_radio)->active)
	{
		fputs ("3\n",fp);
	}
	
	/* save wep active */

	if (GTK_TOGGLE_BUTTON (wep_toggle)->active)
	{
		fputs ("wep on\n",fp);
	}else if (!GTK_TOGGLE_BUTTON (wep_toggle)->active)
	{
		fputs ("wep off\n",fp);
	}
		
	fclose(fp);
}

	
	
int main (int argc, char *argv[])
{
  gtk_init (&argc,&argv);
  SSID_LOAD=(char*)calloc(1,32);
  strcat (SSID_LOAD,"linux-wlan");
  INTFACE_LOAD=(char*)calloc(1,32);
  strcat (INTFACE_LOAD,"wlan0");
  CHAN_LOAD=(char*)calloc(1,2);
  strcat (CHAN_LOAD,"6");
  create_main_window ();
  create_help_window ();
  gtk_main ();
  free(SSID_LOAD);
  free(INTFACE_LOAD);
  free(CHAN_LOAD);
}

